import { system, world } from "@minecraft/server";

if (world.getDynamicProperty("c:prefix") == undefined) {
    world.setDynamicProperty("c:prefix", "!")
}

function getHome(player) {
    return player.getDynamicProperty("c:home");
}

function setHome(player) {
    return player.setDynamicProperty("c:home", player.location);
}

function removeHome(player) {
    return player.setDynamicProperty("c:home", undefined);
}

world.beforeEvents.chatSend.subscribe(function (data) {
    let prefix = world.getDynamicProperty("c:prefix");
    const sender = data.sender;
    const message = data.message;

    if (message.startsWith(prefix + "changeprefix ")) {
        data.cancel = true;
        if (sender.hasTag("admin")) {
            const newPrefix = message.substring((prefix + "changeprefix ").length);

            world.setDynamicProperty("c:prefix", newPrefix);
            world.sendMessage(`§aPrefix changed to: ${newPrefix}`);
        } else {
            world.sendMessage("§cYou have invalid permissions to use this command.")
        }

    } else if (message == prefix + "home") {
        data.cancel = true;
        system.run(() => {
            const homeLocation = getHome(sender);
            if (homeLocation === undefined) {
                world.sendMessage("§cYou have no home set.")
            } else {
                sender.teleport(homeLocation);
                world.sendMessage("§aYou have been teleported to your home location.")
            }
        });
    } else if (message == prefix + "home set") {
        data.cancel = true;
        setHome(sender);
        world.sendMessage("§aYour home location has been set.")
    } else if (message == prefix + "home remove") {
        data.cancel = true;
        removeHome(sender);
        world.sendMessage("§aRemoved your home location.")
    } else if (message == prefix + "help") {
        data.cancel = true;
        world.sendMessage(`
        §eAvailable commands:\n
        ${prefix}home - Teleport to your home location\n
        ${prefix}home set - Set your home location\n
        ${prefix}home remove - Remove your home location\n
        ${prefix}changeprefix <newprefix> - Change the command prefix
        `);
    } else if (message.startsWith(prefix)) {
        data.cancel = true;
        world.sendMessage(`§cNo command found under that name, use §f${prefix}help§c for a list of available commands!`)
    }
});
